// --------------------------------------------------------------------
// Author  : mashimonator
// Create  : 2009/12/09
// Update  : 2009/12/09
// Description : table要素をソートできるようにする
// --------------------------------------------------------------------

/*@cc_on 
var doc = document;
eval('var document = doc');
@*/
var tableSortExtension = {
	//-----------------------------------------
	// 設定値
	//-----------------------------------------
	conf : {
		targetClass : 'sort'
	},
	storage : {
		tr : null,
		colNo : null,
		sortType : null
	},
	//-----------------------------------------
	// ソート後に呼び出す関数
	//-----------------------------------------
	callFunc : [],
	//-----------------------------------------
	// 初期処理
	//-----------------------------------------
	init : function() {
		var tables = tableSortExtension.getTargetElements('table', tableSortExtension.conf.targetClass);
		var reg = new RegExp(tableSortExtension.conf.targetClass + '\\[.+?\\]', 'i');
		// table数だけLOOP
		for ( var i = 0, len = tables.length; i < len; i++ ) {
			// オプション取得
			var opt = tableSortExtension.getOption(tables[i].className.match(reg));
			// theadが使用されているかチェック
			var thead = tables[i].getElementsByTagName('thead');
			if ( !thead || thead.length < 1 ) {
				thead = tableSortExtension.rebuild(tables[i]);
			} else {
				thead = thead[0];
			}
			// tr要素取得
			var tr = thead.getElementsByTagName('tr');
			for ( var x = 0, len2 = tr.length; x < len2; x++ ) {
				// ヘッダカラム取得
				var th = tr[x].getElementsByTagName('th');
				if ( th.length > 0 && th.length == opt.length ) {
					for ( var z = 0, len3 = th.length; z < len3; z++ ) {
						// ヘッダ要素に情報をセット
						th[z].parentTable = tables[i];
						th[z].parentRow = tr[x];
						th[z].colNo = z;
						th[z].sortType = opt[z];
						th[z].sortOrder = 'asc';
						if ( !opt[z].match(/none/i) ) {
							th[z].innerHTML += ' #';
							// イベント付加
							tableSortExtension.addEvent(th[z], 'click', function(){
								tableSortExtension.sort(this.parentTable, this.colNo, this.sortType, this.sortOrder);
								tableSortExtension.resetHeadingText(this.parentRow);
								switch ( this.sortOrder ) {
									case 'asc':
										this.sortOrder = 'desc';
										this.innerHTML = this.innerHTML.replace(/ .+?$/i, ' ▼');
										break;
									case 'desc':
										this.sortOrder = 'asc';
										this.innerHTML = this.innerHTML.replace(/ .+?$/i, ' ▲');
										break;
								}
							});
							// スタイルセット
							th[z].style.cursor = 'pointer';
						}
					}
				}
			}
		}
	},
	//-----------------------------------------
	// テーブル再構築
	//-----------------------------------------
	rebuild : function( table ) {
		var thead = document.createElement('thead');
		var tr = table.getElementsByTagName('tr');
		for ( var i = 0, len = tr.length; i < len; i++ ) {
			if ( tableSortExtension.checkHeader(tr[i]) ) {
				thead.appendChild(tr[i]);
				break;
			}
		}
		table.insertBefore(thead , table.getElementsByTagName('tbody')[0]);
		return thead;
	},
	//-----------------------------------------
	// ソート処理
	//-----------------------------------------
	sort : function( table, colNo, sortType, sortOrder ) {
		var cells = new Array();
		var rowIds = new Array();
		// カラム番号とソート方式を保持
		tableSortExtension.storage.colNo = colNo;
		tableSortExtension.storage.sortType = sortType;
		// tr要素のリストを取り出す
		tableSortExtension.storage.tr = table.getElementsByTagName('tbody')[0].getElementsByTagName('tr');
		// テーブルの内容を保持
		for ( var nRow = 0, len = tableSortExtension.storage.tr.length; nRow < len; nRow++ ) {
			rowIds[nRow] = nRow;
			var td = tableSortExtension.storage.tr[nRow].getElementsByTagName('td');
			cells[nRow] = new Array();
			for ( var nCol = 0, len2 = td.length; nCol < len2; nCol++) {
				cells[nRow][nCol] = td[nCol];
			}
		}
		// ソート
		switch ( sortOrder ) {
			case 'asc':
				rowIds.sort(tableSortExtension.compareRowsAsc);
				break;
			case 'desc':
				rowIds.sort(tableSortExtension.compareRowsDesc);
				break;
		}
		// 保持していた内容をテーブルに書き戻す
		var newTbody = document.createElement('tbody');
		for ( var nRow = 0, len = tableSortExtension.storage.tr.length; nRow < len; nRow++) {
			var newTr = tableSortExtension.storage.tr[rowIds[nRow]].cloneNode(false);
			for ( var nCol = 0, len2 = cells[rowIds[nRow]].length; nCol < len2; nCol++) {
				newTr.appendChild(cells[rowIds[nRow]][nCol]);
			}
			newTbody.appendChild(newTr);
		}
		// 再構築
		table.replaceChild(newTbody, table.getElementsByTagName('tbody')[0]);
		// 指定関数呼出
		for ( var i = 0, len = tableSortExtension.callFunc.length; i < len; i++) {
			eval(tableSortExtension.callFunc[i])();
			//tableSortExtension.callFunc[i]();
		}
		// リセット
		tableSortExtension.storage.tr = null;
		tableSortExtension.storage.colNo = null;
		tableSortExtension.storage.sortType = null;
	},
	//-----------------------------------------
	// テーブルソートのための比較関数（昇順）
	//-----------------------------------------
	compareRowsAsc : function(a, b) {
		var val1 = tableSortExtension.getSortValue(a);
		var val2 = tableSortExtension.getSortValue(b);
		if ( val1 == val2 ) {
			return 0;
		} else if ( val1 > val2 ) {
			return 1;
		} else {
			return -1;
		}
	},
	//-----------------------------------------
	// テーブルソートのための比較関数（降順）
	//-----------------------------------------
	compareRowsDesc : function(a, b) {
		var val1 = tableSortExtension.getSortValue(a);
		var val2 = tableSortExtension.getSortValue(b);
		if ( val1 == val2 ) {
			return 0;
		} else if ( val1 < val2 ) {
			return 1;
		} else {
			return -1;
		}
	},
	//-----------------------------------------
	// tr要素から比較値を取得する
	//-----------------------------------------
	getSortValue : function( row ) {
		var val = '';
		var td = tableSortExtension.storage.tr[row].getElementsByTagName('td')[tableSortExtension.storage.colNo];
		switch ( tableSortExtension.storage.sortType ) {
			// for the text of the character string form
			case 'str':
				td = tableSortExtension.getFirstElement(td);
				val = td.innerHTML;
				break;
			// for the text of the numerical value form
			case 'num':
				td = tableSortExtension.getFirstElement(td);
				val = parseFloat(td.innerHTML);
				break;
			// for the text of the date form
			case 'date':
				td = tableSortExtension.getFirstElement(td);
				datestr = td.innerHTML.replace(/ /, '');
				var year = parseInt(datestr.substr( 0, 4  ), 10);
				var month = parseInt(datestr.substr( 5, 2 ), 10) - 1;
				var day = parseInt(datestr.substr( 8, 2 ), 10);
				var hour = datestr.substr( 10, 2 );
				var minute = datestr.substr( 13, 2 );
				var second = datestr.substr( 16, 2 );
				var adate = new Date(year, month, day);
				if ( hour && hour != '' ) {
					adate.setHours( parseInt(hour ,10) );
				} else {
					adate.setHours(0);
				}
				if ( minute && minute != '' ) {
					adate.setMinutes( parseInt(minute, 10) );
				} else {
					adate.setMinutes(0);
				}
				if ( second && second != '' ) {
					adate.setSeconds( parseInt(second, 10) );
				} else {
					adate.setSeconds(0);
				}
				val = adate.getTime();
				break;
			case 'date-ymd':
				td = tableSortExtension.getFirstElement(td);
				datestr = td.innerHTML.replace(/ /, '');
				var year = parseInt(datestr.substr( 0, 4  ), 10);
				var month = parseInt(datestr.substr( 5, 2 ), 10) - 1;
				var day = parseInt(datestr.substr( 8, 2 ), 10);
				var adate = new Date(year, month, day);
				val = adate.getTime();
				break;
			case 'date-ymdh':
				td = tableSortExtension.getFirstElement(td);
				datestr = td.innerHTML.replace(/ /, '');
				var year = parseInt(datestr.substr( 0, 4  ), 10);
				var month = parseInt(datestr.substr( 5, 2 ), 10) - 1;
				var day = parseInt(datestr.substr( 8, 2 ), 10);
				var hour = datestr.substr( 10, 2 );
				var adate = new Date(year, month, day);
				adate.setHours( parseInt(hour ,10) );
				val = adate.getTime();
				break;
			case 'date-ymdhm':
				td = tableSortExtension.getFirstElement(td);
				datestr = td.innerHTML.replace(/ /, '');
				var year = parseInt(datestr.substr( 0, 4  ), 10);
				var month = parseInt(datestr.substr( 5, 2 ), 10) - 1;
				var day = parseInt(datestr.substr( 8, 2 ), 10);
				var hour = datestr.substr( 10, 2 );
				var minute = datestr.substr( 13, 2 );
				var adate = new Date(year, month, day);
				adate.setHours( parseInt(hour ,10) );
				adate.setMinutes( parseInt(minute, 10) );
				val = adate.getTime();
				break;
			case 'date-ymdhms':
				td = tableSortExtension.getFirstElement(td);
				datestr = td.innerHTML.replace(/ /, '');
				var year = parseInt(datestr.substr( 0, 4  ), 10);
				var month = parseInt(datestr.substr( 5, 2 ), 10) - 1;
				var day = parseInt(datestr.substr( 8, 2 ), 10);
				var hour = datestr.substr( 10, 2 );
				var minute = datestr.substr( 13, 2 );
				var second = datestr.substr( 16, 2 );
				var adate = new Date(year, month, day);
				adate.setHours( parseInt(hour ,10) );
				adate.setMinutes( parseInt(minute, 10) );
				adate.setSeconds( parseInt(second, 10) );
				val = adate.getTime();
				break;
			// for a element
			case 'link':
				val = td.getElementsByTagName('a')[0].innerHTML;
				break;
			case 'href':
				val = td.getElementsByTagName('a')[0].getAttribute('href');
				break;
			// for image element
			case 'src':
				val = td.getElementsByTagName('img')[0].getAttribute('src');
				break;
			case 'alt':
				val = td.getElementsByTagName('img')[0].getAttribute('alt');
				break;
			// for input element
			case 'value':
				val = td.getElementsByTagName('input')[0].value;
				break;
			case 'checked':
				val = td.getElementsByTagName('input')[0].checked;
				break;
		}
		return val;
	},
	//-----------------------------------------
	// 指定された要素の最初の子要素を返す
	//-----------------------------------------
	getFirstElement : function ( element ) {
		var result = element;
		var children = element.childNodes;
		for (var i = 0, len = children.length; i < len; i++) {
			if ( children[i].nodeType == '1' && children[i].nodeName.match(/(p|span|div|a|pre|code)/i) ) {
				result = children[i];
				break;
			}
		}
		return result;
	},
	//-----------------------------------------
	// ソート記号のリセット
	//-----------------------------------------
	resetHeadingText : function( head ) {
		var th = head.getElementsByTagName('th');
		for ( var i = 0, len = th.length; i < len; i++ ) {
			th[i].innerHTML = th[i].innerHTML.replace(/ .+?$/i, ' #');
		}
	},
	//-----------------------------------------
	// Class名からオプションを抽出する
	//-----------------------------------------
	getOption : function( str ) {
		var opt = new Array;
		if ( str && str != '' ) {
			// クラス名からオプション抜き出し
			str += '';
			str = str.replace(tableSortExtension.conf.targetClass, '');
			str = str.replace('[', '');
			str = str.replace(']', '');
			opt = str.split(',');
		}
		return opt;
	},
	//-----------------------------------------
	// tr要素にtd要素が含まれているかをチェックする
	//-----------------------------------------
	checkHeader : function( tr ) {
		var parent = tr.parentNode;
		if ( parent.nodeName && parent.nodeName.match(/thead/i) ) {
			return true;
		}
		var td = tr.getElementsByTagName('td');
		if ( td && td.length > 0 ) {
			return false;
		} else {
			return true;
		}
	},
	//-----------------------------------------
	// ターゲットタグを取得する
	//-----------------------------------------
	getTargetElements : function( tag, cls ) {
		var elements = new Array();
		var targetElements = document.getElementsByTagName(tag.toUpperCase());
		for ( var i = 0, len = targetElements.length; i < len; i++ ) {
			if ( targetElements[i].className.match(cls) ) {
				elements[elements.length] = targetElements[i];
			}
		}
		return elements;
	},
	//-----------------------------------------
	// イベントに関数を付加する
	//-----------------------------------------
	addEvent : function( target, event, func ) {
		try {
			target.addEventListener(event, func, false);
		} catch (e) {
			target.attachEvent('on' + event, (function(el){return function(){func.call(el);};})(target));
		}
	}
}
// 実行
tableSortExtension.addEvent( window, 'load', tableSortExtension.init );